'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _openpgp = require('openpgp');

var openpgp = _interopRequireWildcard(_openpgp);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ConversationsFetcher = function () {
    function ConversationsFetcher(cookie, sessionId, privateKey) {
        _classCallCheck(this, ConversationsFetcher);

        this._headers = {
            cookie: cookie,
            'x-pm-apiversion': '1',
            'x-pm-appversion': 'Web_3.5.12',
            'x-pm-session': sessionId
        };
        this._privateKey = privateKey;
    }

    _createClass(ConversationsFetcher, [{
        key: 'getConversationsList',
        value: function () {
            var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
                var url, result;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                url = ConversationsFetcher.BASE_URL + '/conversations?Label=6&Limit=10&Page=0';
                                _context.next = 3;
                                return (0, _nodeFetch2.default)(url, { headers: this._headers });

                            case 3:
                                result = _context.sent;
                                _context.next = 6;
                                return result.json();

                            case 6:
                                return _context.abrupt('return', _context.sent);

                            case 7:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function getConversationsList() {
                return _ref.apply(this, arguments);
            }

            return getConversationsList;
        }()
    }, {
        key: 'populateConversation',
        value: function () {
            var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(conversation) {
                var url, result, newConversation;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                url = ConversationsFetcher.BASE_URL + '/conversations/' + conversation.ID;
                                _context2.next = 3;
                                return (0, _nodeFetch2.default)(url, { headers: this._headers });

                            case 3:
                                result = _context2.sent;
                                _context2.next = 6;
                                return result.json();

                            case 6:
                                newConversation = _context2.sent;

                                Object.assign(conversation, newConversation.Conversation, { Messages: newConversation.Messages });
                                return _context2.abrupt('return', conversation);

                            case 9:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function populateConversation(_x) {
                return _ref2.apply(this, arguments);
            }

            return populateConversation;
        }()
    }, {
        key: 'getMessagesFromConversation',
        value: function () {
            var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(conversation) {
                var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, message;

                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                _iteratorNormalCompletion = true;
                                _didIteratorError = false;
                                _iteratorError = undefined;
                                _context3.prev = 3;
                                _iterator = conversation.Messages[Symbol.iterator]();

                            case 5:
                                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                                    _context3.next = 16;
                                    break;
                                }

                                message = _step.value;

                                if (message.Body) {
                                    _context3.next = 10;
                                    break;
                                }

                                _context3.next = 10;
                                return this.populateMessage(message);

                            case 10:
                                if (message.BodyDecrypted) {
                                    _context3.next = 13;
                                    break;
                                }

                                _context3.next = 13;
                                return this.decryptMessageBody(message);

                            case 13:
                                _iteratorNormalCompletion = true;
                                _context3.next = 5;
                                break;

                            case 16:
                                _context3.next = 22;
                                break;

                            case 18:
                                _context3.prev = 18;
                                _context3.t0 = _context3['catch'](3);
                                _didIteratorError = true;
                                _iteratorError = _context3.t0;

                            case 22:
                                _context3.prev = 22;
                                _context3.prev = 23;

                                if (!_iteratorNormalCompletion && _iterator.return) {
                                    _iterator.return();
                                }

                            case 25:
                                _context3.prev = 25;

                                if (!_didIteratorError) {
                                    _context3.next = 28;
                                    break;
                                }

                                throw _iteratorError;

                            case 28:
                                return _context3.finish(25);

                            case 29:
                                return _context3.finish(22);

                            case 30:
                                return _context3.abrupt('return', conversation.Messages);

                            case 31:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this, [[3, 18, 22, 30], [23,, 25, 29]]);
            }));

            function getMessagesFromConversation(_x2) {
                return _ref3.apply(this, arguments);
            }

            return getMessagesFromConversation;
        }()
    }, {
        key: 'populateMessage',
        value: function () {
            var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4(message) {
                var url, result, newMessage;
                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                url = ConversationsFetcher.BASE_URL + '/messages/' + message.ID;
                                _context4.next = 3;
                                return (0, _nodeFetch2.default)(url, { headers: this._headers });

                            case 3:
                                result = _context4.sent;
                                _context4.next = 6;
                                return result.json();

                            case 6:
                                newMessage = _context4.sent;

                                Object.assign(message, newMessage.Message);

                            case 8:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this);
            }));

            function populateMessage(_x3) {
                return _ref4.apply(this, arguments);
            }

            return populateMessage;
        }()
    }, {
        key: 'decryptMessageBody',
        value: function () {
            var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5(message) {
                var messageBody;
                return regeneratorRuntime.wrap(function _callee5$(_context5) {
                    while (1) {
                        switch (_context5.prev = _context5.next) {
                            case 0:
                                _context5.next = 2;
                                return openpgp.decrypt({
                                    message: openpgp.message.readArmored(message.Body),
                                    privateKey: this._privateKey
                                });

                            case 2:
                                messageBody = _context5.sent;

                                message.BodyDecrypted = messageBody.data;
                                return _context5.abrupt('return', message);

                            case 5:
                            case 'end':
                                return _context5.stop();
                        }
                    }
                }, _callee5, this);
            }));

            function decryptMessageBody(_x4) {
                return _ref5.apply(this, arguments);
            }

            return decryptMessageBody;
        }()
    }]);

    return ConversationsFetcher;
}();

ConversationsFetcher.BASE_URL = 'https://mail.protonmail.com/api';
exports.default = ConversationsFetcher;